#include"main.h"
/***************************************************************************
    "SVT" Phillip Blair's Spanish Vocabulary Tutor 
    Copyright (C) 1997  Phillip Vaughn Blair
    phillip_blair@writeme.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

**************************************************************************/

int main(void)
{
   char *homemarker;
   char num_file_path[425];
   FILE *num_stream;
   
   /* initialize() wuz `ere */
		/* initialize the ncurses stuff */
   win1 = initscr();
   start_color();
   cbreak();
   noecho();
   nonl();
   intrflush(stdscr, FALSE);
   keypad(stdscr, TRUE);
        /* initialize all else (I mean...for this sub-routine zeen?) */
   /* initialise the random numbers */
   srand(time(0));
   atexit(quit);
      /* initialize() done */
   
/*   initialise_environment();  */
   /* makeup the pathname of our .spanishrc file */
   if((homemarker = getenv("HOME"))==NULL)
     {
	beep();
	move(17,10);
	addstr("there's no HOME environment variable defined");
	refresh();
	sleep(1);
	exit(EXIT_FAILURE);
     }
   else
     {
	strcpy(home,homemarker);
	strcat(home,"/.spanishrc");
     }/*yes..we now have a pathname for our file..*/
   
   /*interact w/ the .spanishrc file*/
   if((rcstream = fopen(home,"r"))==NULL)
     {   /* can't open the .spanishrc file for reading */
	beep();
	move(17,10);
	addstr("error:there's no .spanishrc file in your home directory");
	move(18,10);
	addstr("copy the one from where the archive was expanded RTFM!");
	refresh();
	exit(EXIT_FAILURE);
     }
   else
     {	/* else there is a .spanishrc file */
	char *lineptr,cool_to_leave = 0;
	size_t length;
	do	/* find & extract the line that begins w/ DATABASE_DIRECTORY */
	  {
	     lineptr = NULL;
	     length = 0;

	     if((getdelim(&lineptr,&length,'\n',rcstream))==-1)
	       {
		  puts("");
		  puts("couldn't find a SPANISH_DATABASE_DIRECTORY line in .spanishrc");
		  exit(EXIT_FAILURE);
	       }
	     /* but if no problems reading the line out of the file,parse it */
	     /* parse it */
	     if(sscanf(lineptr," SPANISH_DATABASE_DIRECTORY %400s ",data_dir_name))
		  cool_to_leave = 1;
	     free(lineptr);
	     
	  }while(!cool_to_leave);
     }
   /* okay,get our running_total */
   /* open the file */
   strcpy(num_file_path,data_dir_name);
   strcat(num_file_path,"/numbers");

   if((num_stream = fopen(num_file_path,"r"))==NULL)
     {
	move(17,10);
	addstr("the file `numbers' in the path:");
	move(18,10);	
	addstr(num_file_path);
	move(19,10);
	addstr("does not exist");
	move(20,10);
	addstr("creating....");
	beep();
	refresh();
	if((num_stream = fopen(num_file_path,"w"))==NULL)
	  {
	     beep();
	     move(21,10);
	     addstr("having trouble creating the file...giving up");
	     refresh();
	     exit(EXIT_FAILURE);
	  }
	else
	  { /* file created,write zero to it  and the variable */
	     running_total = 0;
	     fprintf(num_stream,"RUNNING_TOTAL %lu \n",running_total);
	     fclose(num_stream);
	     sleep(3);
	  }
     }
   else
     {
	/*else we've successfully opened the file,so..*/
	if((fscanf(num_stream,"RUNNING_TOTAL %lu \n",&running_total)) < 1)
	  {
	     move(17,10);
	     addstr("couldn't get a RUNNING_TOTAL out of 'numbers'");
	     move(18,10);
	     addstr("I give up...");
	     refresh();
	     exit(EXIT_FAILURE);
	  }
	/* else I've gotten a running total,and that's it...so... */
     }

      /* end initialise_environment */
   show_copyright();   /* this is a module to use in other textmode stuff */
   paint_screen();   /* MUST keep this,look down babe... */
  /*done initialising things... play the waiting game*/
   do
     {
	character = getch();
	switch(character)
	  {
	   case 'w':
	     practise_nouns();
	     erase();
	     paint_screen();/*put back the menu screen*/
	     break;
	   case 'e':
	     build_database();
	     erase();
	     paint_screen();/*put back the menu screen*/
	     break;
	   case 'r':
	     view_database();
	     erase();
	     paint_screen();/*put back the menu screen*/
	     break;	   
	   case 'q':
	     refresh();
	     exit(EXIT_SUCCESS);
	     break;	     
	   default :
	     break;
	  }
     }
   while(character!='q');
   
   
   sleep(2);
   
   exit(EXIT_SUCCESS);
}
void quit(void)
{
   endwin();
}



